/*
 * Copyright 2018-2020,2023 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/

/*! @brief Direction type  */
typedef enum _pin_mux_direction
{
  kPIN_MUX_DirectionInput = 0U,         /* Input direction */
  kPIN_MUX_DirectionOutput = 1U,        /* Output direction */
  kPIN_MUX_DirectionInputOrOutput = 2U  /* Input or output direction */
} pin_mux_direction_t;

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

#define BOARD_INITPINS_IOMUXC_GPR_GPR26_GPIO_MUX1_GPIO_SEL_MASK 0x0600U /*!< GPIO1 and GPIO6 share same IO MUX function, GPIO_MUX1 selects one GPIO function: affected bits mask */

/* GPIO_AD_B0_13 (coord L14), UART1_RXD/J11[2] */
/* Routed pin properties */
#define BOARD_INITPINS_UART1_RXD_PERIPHERAL                              LPUART1   /*!< Peripheral name */
#define BOARD_INITPINS_UART1_RXD_SIGNAL                                       RX   /*!< Signal name */

/* GPIO_AD_B0_12 (coord K14), UART1_TXD/J13[2] */
/* Routed pin properties */
#define BOARD_INITPINS_UART1_TXD_PERIPHERAL                              LPUART1   /*!< Peripheral name */
#define BOARD_INITPINS_UART1_TXD_SIGNAL                                       TX   /*!< Signal name */

/* GPIO_EMC_40 (coord A7), ENET_MDC/U18[12] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_MDC_PERIPHERAL                                  ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_MDC_SIGNAL                                  enet_mdc   /*!< Signal name */

/* GPIO_EMC_41 (coord C7), ENET_MDIO/U18[11] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_MDIO_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_MDIO_SIGNAL                                enet_mdio   /*!< Signal name */

/* GPIO_B1_10 (coord B13), ENET_TX_REF_CLK/U18[9] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_TX_REF_CLK_PERIPHERAL                           ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_TX_REF_CLK_SIGNAL                       enet_ref_clk   /*!< Signal name */

/* GPIO_B1_04 (coord E12), ENET_RXD0/U18[16] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_RXD0_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_RXD0_SIGNAL                             enet_rx_data   /*!< Signal name */
#define BOARD_INITPINS_ENET_RXD0_CHANNEL                                      0U   /*!< Signal channel */

/* GPIO_B1_05 (coord D12), ENET_RXD1/U18[15] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_RXD1_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_RXD1_SIGNAL                             enet_rx_data   /*!< Signal name */
#define BOARD_INITPINS_ENET_RXD1_CHANNEL                                      1U   /*!< Signal channel */

/* GPIO_B1_06 (coord C12), ENET_CRS_DV/U18[18] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_CRS_DV_PERIPHERAL                               ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_CRS_DV_SIGNAL                             enet_rx_en   /*!< Signal name */

/* GPIO_B1_11 (coord C13), ENET_RXER/U18[20] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_RXER_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_RXER_SIGNAL                               enet_rx_er   /*!< Signal name */

/* GPIO_B1_07 (coord B12), ENET_TXD0/U18[24] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_TXD0_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_TXD0_SIGNAL                             enet_tx_data   /*!< Signal name */
#define BOARD_INITPINS_ENET_TXD0_CHANNEL                                      0U   /*!< Signal channel */

/* GPIO_B1_08 (coord A12), ENET_TXD1/U18[25] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_TXD1_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_TXD1_SIGNAL                             enet_tx_data   /*!< Signal name */
#define BOARD_INITPINS_ENET_TXD1_CHANNEL                                      1U   /*!< Signal channel */

/* GPIO_B1_09 (coord A13), ENET_TXEN/U18[23] */
/* Routed pin properties */
#define BOARD_INITPINS_ENET_TXEN_PERIPHERAL                                 ENET   /*!< Peripheral name */
#define BOARD_INITPINS_ENET_TXEN_SIGNAL                               enet_tx_en   /*!< Signal name */

/* GPIO_AD_B0_10 (coord G13), JTAG_TDO/J2[13]/J3[2]/ENET_INT/U18[21]/INT1_COMBO/U12[11]/DC_I2S2_MCLK/J19[1]/J16[6] */
/* Routed pin properties */
#define BOARD_INITPINS_PHY_INTR_PERIPHERAL                                 GPIO1   /*!< Peripheral name */
#define BOARD_INITPINS_PHY_INTR_SIGNAL                                   gpio_io   /*!< Signal name */
#define BOARD_INITPINS_PHY_INTR_CHANNEL                                      10U   /*!< Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITPINS_PHY_INTR_GPIO                                       GPIO1   /*!< GPIO peripheral base pointer */
#define BOARD_INITPINS_PHY_INTR_GPIO_PIN                                     10U   /*!< GPIO pin number */
#define BOARD_INITPINS_PHY_INTR_GPIO_PIN_MASK                        (1U << 10U)   /*!< GPIO pin mask */
#define BOARD_INITPINS_PHY_INTR_PORT                                       GPIO1   /*!< PORT peripheral base pointer */
#define BOARD_INITPINS_PHY_INTR_PIN                                          10U   /*!< PORT pin number */
#define BOARD_INITPINS_PHY_INTR_PIN_MASK                             (1U << 10U)   /*!< PORT pin mask */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void);

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
